// Made by Jiri Stepanovsky, jiristepanovsky.cz


#include "ev3_terminal.h"

char terminalLines[TERMINAL_LINES][TERMINAL_LINE_WIDTH];
int terminalLinesUsed = 0;
int terminalLineStart = 0;
bool terminalInitialized = false;
void TerminalClearLine(int line);

bool TerminalInit(){
    if(!LcdInit())
        return false;
    terminalInitialized = true;
    TerminalClear();
    return true;
}

bool TerminalExit(){
    TerminalAddText("EXIT...");
    terminalInitialized = false;
    return LcdExit();
}

bool TerminalInitialized(){
    return terminalInitialized;
}

void TerminalAddText(char *s){
    if(!terminalInitialized)
        return;
    if(terminalLinesUsed < TERMINAL_LINES){
        TerminalClearLine(terminalLinesUsed);
        strncpy(terminalLines[terminalLinesUsed], s, TERMINAL_LINE_WIDTH);
        terminalLinesUsed++;
    } else {
        TerminalClearLine(terminalLineStart);
        strncpy(terminalLines[terminalLineStart], s, TERMINAL_LINE_WIDTH);
        terminalLineStart++;
        if(terminalLineStart >= TERMINAL_LINES)
            terminalLineStart = 0;
    }
    TerminalRefresh();
}

void TerminalAddNumber(int number){
    if(!terminalInitialized)
        return;
    TerminalAddTextAndNumber("", number);
}

void TerminalAddTextAndNumber(char *s, int number){
    if(!terminalInitialized)
        return;
    char str1[TERMINAL_LINE_WIDTH];
    char str2[TERMINAL_LINE_WIDTH+1];
    strncpy(str1, s, TERMINAL_LINE_WIDTH);
    snprintf(str2, TERMINAL_LINE_WIDTH+1, "%d", number);
    int len = strlen(s);
    if(len > TERMINAL_LINE_WIDTH)
        len = TERMINAL_LINE_WIDTH;
    strncat(str1, str2, TERMINAL_LINE_WIDTH - len);
    TerminalAddText(str1);
}

void TerminalRefresh(){
    if(!terminalInitialized)
        return;
    LcdClearDisplay();
    int i = 0, line = terminalLineStart;
    for(i = 0; i < TERMINAL_LINES; i++){
        LcdTextLength(1, TERMINAL_LEFT_SPACE, (i*TERMINAL_LINE_HEIGHT)+TERMINAL_TOP_SPACE, terminalLines[line], TERMINAL_LINE_WIDTH);
        line++;
        if(line >= TERMINAL_LINES)
            line = 0;
    }
    LcdRefresh();
}

void TerminalClear(){
    if(!terminalInitialized)
        return;
    int i;
    for(i = 0; i < TERMINAL_LINES; i++)
        TerminalClearLine(i);
    terminalLinesUsed = 0;
    terminalLineStart = 0;
    TerminalRefresh();
}

void TerminalClearLine(int line){
    int i;
    for(i = 0; i < TERMINAL_LINE_WIDTH; i++)
        terminalLines[line][i] = 0;
}

